program CaseEnum;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils;

type
  TEnum = (enum1, enum2, enum3 {, enum4});

var
  a: TEnum;

begin
  a := High(TEnum);

  // We _know_ that we have to do something for each possible enum.
  // This code will break if more elements are added to the enum because it will ignore
  // all new elements.
  case a of
    enum1: ;
    enum2: ;
    enum3: ;
  end;

  // Future-proof version
  case a of
    enum1: ;
    enum2: ;
    enum3: ;
    else raise Exception.Create('Invalid value of TEnum');
  end;
end.
