program FizzBuzzAnon;

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils;

var
  FizzBuzz: TFunc<integer,string>;
  i: integer;

begin
  try

    FizzBuzz :=
      function (n: integer): string
      var
        fizz: TFunc<TFunc<string,string>,TFunc<string,string>>;
        buzz: TFunc<TFunc<string,string>,TFunc<string,string>>;
        id  : TFunc<string,string>;
      begin
        fizz :=
          function (f: TFunc<string,string>): TFunc<string,string>
          begin
            if (n mod 3) = 0 then
              Result :=
                function (s: string): string
                begin
                  Result := 'Fizz' + f('');
                end
            else
              Result := f;
          end;
        buzz :=
          function (f: TFunc<string,string>): TFunc<string,string>
          begin
            if (n mod 5) = 0 then
              Result :=
                function (s: string): string
                begin
                  Result := 'Buzz' + f('');
                end
            else
        id :=
          function (s: string): string
          begin
            Result := s;
          end;
        Result := fizz(buzz(id))(IntToStr(n));
      end;

    for i := 1 to 17 do
      Writeln(FizzBuzz(i));
    Readln;

  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.

